SystemOrganization addCategory: #'Seaside-Tests-Slime'!

!WAPackage class methodsFor: '*Seaside-Tests-Slime' stamp: 'jf 10/23/2008 11:12'!
seasideTestsSlime
	^ self new
		name: 'Seaside-Tests-Slime';
		description: 'foo';
		addDependency: 'Seaside-Slime';
		yourself! !

Object subclass: #SlimeMockObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!SlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:44'!
callbackTemps
	| r |
	r := OrderedCollection new.
	(1 to: 10) do: [ :e | r add: [ e ] ]! !

!SlimeMockObject methodsFor: 'initialize-release' stamp: 'lr 7/15/2008 23:10'!
initialize
	super initialize! !

!SlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:13'!
someClass
	Semaphore new! !

!SlimeMockObject methodsFor: 'accessing' stamp: 'lr 7/15/2008 23:26'!
someMessage
	^ true and: [ false ] and: [ nil ]! !

WAComponent subclass: #SlimeMockComponent
	instanceVariableNames: 'foo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!SlimeMockComponent methodsFor: 'initialize-release' stamp: 'lr 7/15/2008 22:16'!
initialize
	"Does not send super"! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:21'!
renderAvoidUnnecessaryWithOn: html
	html div with: 'foo'! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:36'!
renderChangesStateWhileRenderingOn: html
	html div: [ foo := nil ]! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:24'!
renderContentOn: html
	super renderContentOn: html! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:17'!
renderDoNotUseWhileRenderingOn: html
	html div: [ self call: foo ]! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:17'!
renderDoNotUseWithinCallbackOn: html
	html anchor
		callback: [ self session addLoadScript: nil ];
		with: 'foo'! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:22'!
renderExtractCallbackCodeToMethodOn: html
	html anchor callback: [ self foo. self bar ]; with: 'foo'! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:03'!
renderInstantiatesComponentWhileRenderingOn: html
	html div: WABrowser new! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:38'!
renderSendsDeprecatedMessageOn: html
	html anchor src: 'http://www.foo.com'; with: 'Foo'! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:35'!
renderUnnecessaryBlockPassedToBrushOn: html
	html div: [ html render: 'foo' ]! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 23:08'!
renderUsesWrongRendererOn: html
	html updater callback: [ :r | html div ]! !

!SlimeMockComponent methodsFor: 'rendering' stamp: 'lr 7/15/2008 22:27'!
renderWithHasToBeLastMessageInCascadeOn: html
	html div
		with: 'foo';
		class: 'bar'! !

!SlimeMockComponent methodsFor: 'actions' stamp: 'lr 7/15/2008 23:26'!
sendsRenderContentOn
	self renderContentOn: nil! !

WASession subclass: #SlimeMockSession
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!SlimeMockSession methodsFor: 'as yet unclassified' stamp: 'pmm 10/18/2008 20:27'!
expired! !

TestCase subclass: #SlimeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Slime'!

!SlimeTest methodsFor: 'actions' stamp: 'pmm 10/18/2008 20:42'!
run: aRule selectors: aSelectorCollection
	self 
		run: aRule selectors: aSelectorCollection 
		in: (Array with: SlimeMockComponent with: SlimeMockObject with: SlimeMockSession)! !

!SlimeTest methodsFor: 'actions' stamp: 'lr 7/15/2008 23:41'!
run: aRule selectors: aSelectorCollection in: aClassCollection 
	| searchEnvironment resultEnvironment |
	searchEnvironment := ClassEnvironment 
		onEnvironment: BrowserEnvironment new
		classes: aClassCollection.
	SmalllintChecker
		runRule: aRule
		onEnvironment: searchEnvironment.
	resultEnvironment := aRule result.
	self assert: resultEnvironment problemCount = aSelectorCollection size.
	aSelectorCollection do: [ :selector |
		self assert: (resultEnvironment classes
			anySatisfy: [ :class | resultEnvironment includesSelector: selector in: class ]) ]! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:19'!
testAvoidUnnecessaryWith
	self 
		run: SlimeParseTreeLintRule avoidUnnecessaryWith
		selectors: #(renderAvoidUnnecessaryWithOn:)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:10'!
testBasicNewInitializeMissing
	self 
		run: SlimeBlockLintRule basicNewInitializeMissing
		selectors: #(initialize)! !

!SlimeTest methodsFor: 'testing-possible' stamp: 'lr 7/15/2008 23:36'!
testChangesStateWhileRendering
	self 
		run: SlimeBlockLintRule changesStateWhileRendering
		selectors: #(renderChangesStateWhileRenderingOn:)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 22:53'!
testDoNotUseWhileRendering
	self 
		run: SlimeBlockLintRule doNotUseWhileRendering
		selectors: #(renderDoNotUseWhileRenderingOn:)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 22:53'!
testDoNotUseWithinCallback
	self 
		run: SlimeBlockLintRule doNotUseWithinCallback
		selectors: #(renderDoNotUseWithinCallbackOn:)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 22:54'!
testDoesNotSendSuperInitialize
	self 
		run: SlimeBlockLintRule doesNotSendSuperInitialize
		selectors: #(initialize)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:11'!
testDontCallSuperInitialize
	self 
		run: SlimeBlockLintRule dontCallSuperInitialize
		selectors: #(initialize)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:21'!
testExtractCallbackCodeToMethod
	self 
		run: SlimeParseTreeLintRule extractCallbackCodeToMethod
		selectors: #(renderExtractCallbackCodeToMethodOn:)! !

!SlimeTest methodsFor: 'testing-possible' stamp: 'lr 7/15/2008 23:40'!
testFixCallbackTempsMissing
	self 
		run: SlimeParseTreeLintRule fixCallbackTempsMissing
		selectors: #(callbackTemps)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'pmm 10/18/2008 20:52'!
testImplementsSessionExpired
	self 
		run: SlimeBlockLintRule implementsSessionExpired
		selectors: #(expired)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 22:57'!
testInstantiatesComponentWhileRendering
	self 
		run: SlimeBlockLintRule instantiatesComponentWhileRendering
		selectors: #(renderInstantiatesComponentWhileRenderingOn:)! !

!SlimeTest methodsFor: 'testing-possible' stamp: 'lr 7/15/2008 23:38'!
testSendsDeprecatedMessage
	self 
		run: SlimeBlockLintRule sendsDeprecatedMessage
		selectors: #(renderSendsDeprecatedMessageOn:)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:23'!
testSendsNotPortableMessage
	self 
		run: SlimeParseTreeLintRule sendsNotPortableMessage
		selectors: #(someMessage)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:24'!
testSendsRenderContentOn
	self 
		run: SlimeParseTreeLintRule sendsRenderContentOn
		selectors: #(sendsRenderContentOn)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:35'!
testUnnecessaryBlockPassedToBrush
	self 
		run: SlimeParseTreeLintRule unnecessaryBlockPassedToBrush
		selectors: #(renderUnnecessaryBlockPassedToBrushOn:)! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:18'!
testUsesCurlyBraceArrays
	self 
		run: SlimeBlockLintRule usesCurlyBraceArrays
		selectors: #()! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:18'!
testUsesLiteralByteArrays
	self 
		run: SlimeBlockLintRule usesLiteralByteArrays
		selectors: #()! !

!SlimeTest methodsFor: 'testing-misc' stamp: 'lr 7/15/2008 23:13'!
testUsesNotPortableClass
	self 
		run: SlimeBlockLintRule usesNotPortableClass
		selectors: #(someClass)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 23:06'!
testUsesWrongRenderer
	self 
		run: SlimeParseTreeLintRule usesWrongRenderer
		selectors: #(renderUsesWrongRendererOn:)! !

!SlimeTest methodsFor: 'testing-bugs' stamp: 'lr 7/15/2008 23:08'!
testWithHasToBeLastMessageInCascade
	self 
		run: SlimeParseTreeLintRule withHasToBeLastMessageInCascade
		selectors: #(renderWithHasToBeLastMessageInCascadeOn:)! !
